package com.unitesk.requality.documents;

import java.util.Iterator;
import java.util.LinkedList;

import org.w3c.dom.Node;

public class DeepFirstXMLDOMWalker implements Iterable<Node> {
    private Node dom;

    public DeepFirstXMLDOMWalker(Node dom) {
        this.dom = dom;
    }

    @Override
    public Iterator<Node> iterator() {
        return new Iterator<Node>() {
            private LinkedList<Node> stack = new LinkedList<Node>();
            {
                stack.push(dom);
            }
            private Node lastNode;

            @Override
            public boolean hasNext() {
                return !stack.isEmpty();
            }

            @Override
            public Node next() {
                lastNode = stack.pop();
                for (int i = lastNode.getChildNodes().getLength() - 1; i >= 0; i--) {
                    stack.push(lastNode.getChildNodes().item(i));
                }
                return lastNode;
            }

            @Override
            public void remove() {
                throw new UnsupportedOperationException();
            }
        };
    }
}
