package com.unitesk.requality.eclipse.handlers.requirement;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;

import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.editors.NodeEditorInput;
import com.unitesk.requality.eclipse.editors.browser.ReqMarker;
import com.unitesk.requality.eclipse.views.RequalityCNF;
import com.unitesk.requality.nodetypes.Location;
import com.unitesk.requality.nodetypes.Requirement;

public class OpenRequirementHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        Requirement req = (Requirement) RequalityCNF.getSelectedNode();
        if(req.getLocationQIds().size()==0) {
            return null;
        }
        Location loc = req.getLocation(req.getLocationQIds().get(0));
        NodeEditorInput input = new NodeEditorInput(loc.getParent());
        input.setData(loc);
        try {
            IEditorReference eref = Activator.findMarkEditorForDocument(loc.getParent().getQualifiedId());
            if( eref==null ) {
                PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().openEditor(input, ReqMarker.ID);
            } else {
                ((ReqMarker)eref.getEditor(true)).setTargetLocation(loc);
                eref.getPage().bringToTop(eref.getEditor(true));
            }
        } catch (PartInitException e) {
            e.printStackTrace();
        }
        return null;
    }

}
