package com.unitesk.requality.tests.merge;

public class Pair<T1, T2> implements Comparable<Pair<T1, T2>> {
	protected final T1 Key_;
	protected final T2 Value_;

	public Pair(T1 key, T2 value) {
	    Key_ = key;
	    Value_ = value;
	}

	public T1 getKey() {
	    return Key_;
	}

	public T2 getValue() {
	    return Value_;
	}

	public String toString() {
	    StringBuffer buff = new StringBuffer();
	    buff.append("Key: ");
	    buff.append(Key_);
	    buff.append("\tValue: ");
	    buff.append(Value_);
	    return (buff.toString());
	}

	public int compareTo(Pair<T1, T2> p1) {
	    if (null != p1) {
		if (p1.equals(this)) {
		    return 0;
		} else if (p1.hashCode() > this.hashCode()) {
		    return 1;
		} else if (p1.hashCode() < this.hashCode()) {
		    return -1;
		}
	    }
	    return (-1);
	}

	public boolean equals(Object o) {
	    if (o instanceof Pair) {
		Pair<?, ?> p1 = (Pair<?, ?>) o;
		if (p1.Key_.equals(this.Key_) && p1.Value_.equals(this.Value_)) {
		    return (true);
		}
	    }
	    return (false);
	}

	public int hashCode() {
	    int hashCode = Key_.hashCode() + (31 * Value_.hashCode());
	    return (hashCode);
	}
}