package com.unitesk.requality.tests.merge.sanity;

import java.util.Map;

import junit.framework.TestCase;

import com.unitesk.requality.merge.Fragment;
import com.unitesk.requality.merge.Node;
import com.unitesk.requality.merge.Tree;
import com.unitesk.requality.tests.merge.TestDataHelper;
import com.unitesk.requality.tests.merge.Pair;

import org.w3c.dom.Document;

public class FragmentTest extends TestCase {

    private Map<String, Pair<Document, Document>> testData;

    public void setUp() {
	testData = TestDataHelper.getInstance().getSanityData();
    }

    public void testAttachNode() {
	Document doc = testData.get("Sanity").getKey();
	Tree t = new Tree(doc);
	Fragment frag1 = new Fragment();
	for (Node x : t.getTraversalSequence())
	    frag1.attachNode(x, false);
	assertEquals(t.getTraversalSequence().size() + 1, frag1
		.getTraversalSequence().size());
	Fragment frag2 = new Fragment();
	frag2.attachNode(t.getRoot(), true);
	assertEquals(t.getTraversalSequence().size() + 1, frag2
		.getTraversalSequence().size());
	assertTrue(frag1.isEqual(frag2));
    }
}
