package com.unitesk.requality.tests.merge.sanity;

import java.util.Iterator;
import java.util.Map;

import com.unitesk.requality.merge.Node;
import com.unitesk.requality.merge.Tree;
import com.unitesk.requality.tests.merge.TestDataHelper;
import com.unitesk.requality.tests.merge.Utils;
import com.unitesk.requality.tests.merge.Pair;

import org.w3c.dom.Document;

import junit.framework.*;

public class TreeTest extends TestCase {

    private Map<String, Pair<Document, Document>> testData;

    public void setUp() {
	testData = TestDataHelper.getInstance().getSanityData();
    }

    public void testTraverse() {
	Document doc = testData.get("Sanity").getKey();
	Tree t = new Tree(doc);
	Iterator<Node> i = t.traverse();
	Node prev = i.next();
	while (i.hasNext()) {
	    Node curr = i.next();
	    assertFalse(Utils.isParent(curr, prev));
	    prev = curr;
	}
    }
    
    public void testNearestMatch() {
	Document doc = testData.get("Sanity").getKey();
	Tree t1 = new Tree(doc);
	Tree t2 = new Tree(doc);
	for(Node x : t1.getTraversalSequence()) {
	    Node y = t2.nearestMatch(x).get(0);
	    assertTrue("Expected "+x+", but was "+y,x.isEqual(y));
	}
    }
}
